<?php

/*
|--------------------------------------------------------------------------
| Board class
|--------------------------------------------------------------------------
|
| These are the API routes corresponding to board.
|
*/

// Category
Route::get('/api/rpc/board/category/getcategories', 'BoardController@getCategories');
Route::get('/api/rpc/board/category/getcategory/{id}', 'BoardController@getCategory');
Route::get('/api/rpc/board/category/getcategoryname/{id}', 'BoardController@getCategoryName');

// Forum
Route::get('/api/rpc/board/forum/getforumsincategory/{cat_id}', 'BoardController@getForumsInCategory');
Route::get('/api/rpc/board/forum/getforums', 'BoardController@getForums');
Route::get('/api/rpc/board/forum/getforum/{id}', 'BoardController@getForum');
Route::get('/api/rpc/board/forum/getforumname/{id}', 'BoardController@getForumName');
Route::get('/api/rpc/board/forum/getpostcountfreeze/{id}', 'BoardController@getPostCountFreeze');
Route::get('/api/rpc/board/forum/getreadonly/{id}', 'BoardController@getReadOnly');

// Topic
Route::get('/api/rpc/board/topic/gettopics/{for}/{from}/{to}', 'BoardController@getTopics');
Route::get('/api/rpc/board/topic/gettopicsunpinned/{for}/{from}/{to}', 'BoardController@getTopicsUnpinned');
Route::get('/api/rpc/board/topic/gettopicspinned/{for}/{from}/{to}', 'BoardController@getTopicsPinned');
Route::get('/api/rpc/board/topic/gettopicsuser/{user}/{from}/{to}', 'BoardController@getTopicsUser');
Route::get('/api/rpc/board/topic/countunpinnedtopicsinforum/{for}', 'BoardController@countUnpinnedTopicsInForum');
Route::get('/api/rpc/board/topic/gettopic/{for}/{from}/{to}', 'BoardController@getTopic');
Route::get('/api/rpc/board/topic/gettopiclock/{id}', 'BoardController@getTopicLock');
Route::get('/api/rpc/board/topic/getforumidfromtopic/{top_id}', 'BoardController@getForumIdFromTopic');
Route::get('/api/rpc/board/topic/gettopicname/{id}', 'BoardController@getTopicName');

// Post
Route::get('/api/rpc/board/post/getpostsintopic/{top}/{from}/{to}', 'BoardController@getPostsInTopic');
Route::get('/api/rpc/board/post/countpostsintopic/{top}', 'BoardController@countPostsInTopic');
Route::get('/api/rpc/board/post/getpost/{id}', 'BoardController@getPost');
Route::get('/api/rpc/board/post/getforumidfrompost/{id}', 'BoardController@getForumIdFromPost');
Route::get('/api/rpc/board/post/gettopicidfrompost/{id}', 'BoardController@getTopicIdFromPost');
Route::get('/api/rpc/board/post/getcurrentpostcount/{user_id}', 'BoardController@getCurrentPostCount');
Route::get('/api/rpc/board/post/getnextpostcount/{user_id}', 'BoardController@getNextPostCount');
Route::get('/api/rpc/board/post/getuserposts/{top}/{from}/{to}', 'BoardController@getUserPosts');
Route::get('/api/rpc/board/post/getuserpost/{id}', 'BoardController@getUserPost');
Route::get('/api/rpc/board/post/gettopicstart/{top_id}', 'BoardController@getTopicStart');
Route::get('/api/rpc/board/post/getlastpost/{top_id}', 'BoardController@getLastPost');
Route::get('/api/rpc/board/post/getfirstandlastposts/{top_id}', 'BoardController@getFirstAndLastPosts');

Route::post('/api/rpc/board/post/addpost', 'BoardController@addPost');
Route::post('/api/rpc/board/post/editpost', 'BoardController@editPost');
Route::post('/api/rpc/board/post/deletepost', 'BoardController@deletePost');
Route::post('/api/rpc/board/post/undeletepost', 'BoardController@undeletePost');

// Compiled routes.
Route::get('/api/rpc/board/browse/browsetopicinfo/{tp}/{id}/{to}', 'BoardController@browseTopicInfo');
Route::get('/api/rpc/board/browse/browsetopicposts/{tp}/{id}/{from}/{to}', 'BoardController@browseTopicPosts');
Route::get('/api/rpc/board/browse/browsepermissions/{uid}', 'BoardController@browsePermissions');